#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <stdio.h>
#include <stdlib.h>

#define LED0 0x01
#define LED1 0x02
#define LED2 0x04
#define LED3 0x08
#define LED4 0x10
#define LED5 0x20
#define LED6 0x40
#define LED7 0x80
#define LED8 0x100
#define LED9 0x200
#define LED10 0x400
#define LED11 0x80A

// aprinde butonul primit ca parametru
void LED_ON(int led_nr)
{
	switch(led_nr)
	{
		case 0: PORTD = LED0; break;
		case 1: PORTD = LED1; break;
		case 2: PORTD = LED2; break;
		case 3: PORTD = LED3; break;
		
		case 4: PORTA = LED4; break;
		case 5: PORTA = LED5; break;
		case 6: PORTA = LED6; break;
		case 7: PORTA = LED7; break;
		case 8: PORTA = LED8; break;
		case 9: PORTA = LED9; break;
		case 10: PORTA = LED10; break;
		case 11: PORTA = LED11; break;
	}
}

// toate ledurile licare de 4 ori
void blink_leds()
{
	int i;
	for (i = 0; i < 3; i++)
	{
		PORTA |= (1 << PA0);	
		PORTA |= (1 << PA1);
		PORTA |= (1 << PA2);
		PORTA |= (1 << PA3);
		PORTA |= (1 << PA4);
		PORTA |= (1 << PA5);
		PORTA |= (1 << PA6);
		PORTA |= (1 << PA7);
		
		PORTD |= (1 << PD4);
		PORTD |= (1 << PD5);
		PORTD |= (1 << PD6);
		PORTD |= (1 << PD7);
		
		_delay_ms(100);
		
		PORTA &= ~(1 << PA0);	
		PORTA &= ~(1 << PA1);
		PORTA &= ~(1 << PA2);
		PORTA &= ~(1 << PA3);
		PORTA &= ~(1 << PA4);
		PORTA &= ~(1 << PA5);
		PORTA &= ~(1 << PA6);
		PORTA &= ~(1 << PA7);
		
		PORTD &= ~(1 << PD4);
		PORTD &= ~(1 << PD5);
		PORTD &= ~(1 << PD6);
		PORTD &= ~(1 << PD7);
		
		_delay_ms(100);
	}
}

// returneaza butonul care a fost apasat
int pressed_button()
{	
	while(1) // asteapta sa se apese un buton
	{
		// daca s-a apasat butonul 0
		if((PIND & (1 << PD0)) == 1)
		{
			while ((PIND & (1 << PD0)) == 1)
			{
				LED_ON(0);
				LED_ON(1);
				LED_ON(2);
			}
			PORTA &= ~(1 << PA0);	
			PORTA &= ~(1 << PA1);
			PORTA &= ~(1 << PA2);
			PORTA &= ~(1 << PA3);
			PORTA &= ~(1 << PA4);
			PORTA &= ~(1 << PA5);
			PORTA &= ~(1 << PA6);
			PORTA &= ~(1 << PA7);
		
			PORTD &= ~(1 << PD4);
			PORTD &= ~(1 << PD5);
			PORTD &= ~(1 << PD6);
			PORTD &= ~(1 << PD7);
			return 0;
		}
		// daca s-a apasat butonul 1
		else if((PIND & (1 << PD1)) == 1)
		{
			while ((PIND & (1 << PD1)) == 1)
			{
				LED_ON(3);
				LED_ON(4);
				LED_ON(5);
			}
			PORTA &= ~(1 << PA0);	
			PORTA &= ~(1 << PA1);
			PORTA &= ~(1 << PA2);
			PORTA &= ~(1 << PA3);
			PORTA &= ~(1 << PA4);
			PORTA &= ~(1 << PA5);
			PORTA &= ~(1 << PA6);
			PORTA &= ~(1 << PA7);
		
			PORTD &= ~(1 << PD4);
			PORTD &= ~(1 << PD5);
			PORTD &= ~(1 << PD6);
			PORTD &= ~(1 << PD7);
			return 1;
		}
		// daca s-a apasat butonul 2
		else if((PIND & (1 << PD2)) == 1)
		{
			while ((PIND & (1 << PD2)) == 1)
			{
				LED_ON(6);
				LED_ON(7);
				LED_ON(8);
			}
			PORTA &= ~(1 << PA0);	
			PORTA &= ~(1 << PA1);
			PORTA &= ~(1 << PA2);
			PORTA &= ~(1 << PA3);
			PORTA &= ~(1 << PA4);
			PORTA &= ~(1 << PA5);
			PORTA &= ~(1 << PA6);
			PORTA &= ~(1 << PA7);
		
			PORTD &= ~(1 << PD4);
			PORTD &= ~(1 << PD5);
			PORTD &= ~(1 << PD6);
			PORTD &= ~(1 << PD7);
			return 2;
		}
		// daca s-a apasat butonul 3
		else if((PIND & (1 << PD3)) == 1)
		{
			while ((PIND & (1 << PD3)) == 1)
			{
				LED_ON(9);
				LED_ON(10);
				LED_ON(11);
			}
			PORTA &= ~(1 << PA0);	
			PORTA &= ~(1 << PA1);
			PORTA &= ~(1 << PA2);
			PORTA &= ~(1 << PA3);
			PORTA &= ~(1 << PA4);
			PORTA &= ~(1 << PA5);
			PORTA &= ~(1 << PA6);
			PORTA &= ~(1 << PA7);
		
			PORTD &= ~(1 << PD4);
			PORTD &= ~(1 << PD5);
			PORTD &= ~(1 << PD6);
			PORTD &= ~(1 << PD7);
			return 3;
		}
	}
}

// genereaza secventa random de aprindere
void generate_rand(int array[12])
{
	int i, j, t, n = 12;

	for (i = 0; i < 12; i++)
		array[i] = i;
	
	for (i = 0; i < n - 1; i++) 
	{
		j = i + rand() / (RAND_MAX / (n - i) + 1);
		t = array[j];
		array[j] = array[i];
		array[i] = t;
    }
}

int main()
{
	int crt, i, correct, done, button;
	int ulevel = 1;
	int zlevel = 0;
	int array[12];

	// se seteaza pinii portului A si D ca pini de iesire
	DDRA |= (1 << PA0);
	DDRA |= (1 << PA1);
	DDRA |= (1 << PA2);
	DDRA |= (1 << PA3);
	DDRA |= (1 << PA4);
	DDRA |= (1 << PA5);
	DDRA |= (1 << PA6);
	DDRA |= (1 << PA7);
	
	DDRD |= (1 << PD0);
	DDRD |= (1 << PD1);
	DDRD |= (1 << PD2);
	DDRD |= (1 << PD3);
	
	
	// se seteaza pinii portului D ca pini de intrare
	DDRD &= ~(1 << PD0);
	DDRD &= ~(1 << PD1);
	DDRD &= ~(1 << PD2);
	DDRD &= ~(1 << PD3);
	
	// se activeaza rezistenta de pull-up pe portul D
	PORTD |= (1 << PD0) | (1 << PD1) | (1 << PD2) | (1 << PD3);

	while(1){
	
		// se activeaza rezistenta de pull-up pe portul D
		DDRD &= ~(1 << PD0);
		DDRD &= ~(1 << PD1);
		DDRD &= ~(1 << PD2);
		DDRD &= ~(1 << PD3);
		PORTD |= (1 << PD0) | (1 << PD1) | (1 << PD2) | (1 << PD3);
		
		// genereaza secventa random de aprindere
		generate_rand(array);
				
		// aprinde ledurile
		for (i = 0; i < 12; i++)
		{
			LED_ON(array[i]);
			_delay_ms(400);
		}
		
		// oprim ledurile
		PORTA &= ~(1 << PA0);
		PORTA &= ~(1 << PA1);
		PORTA &= ~(1 << PA2);
		PORTA &= ~(1 << PA3);
		PORTA &= ~(1 << PA4);
		PORTA &= ~(1 << PA5);
		PORTA &= ~(1 << PA6);
		PORTA &= ~(1 << PA7);
		PORTD &= ~(1 << PD0);
		PORTD &= ~(1 << PD1);
		PORTD &= ~(1 << PD2);
		PORTD &= ~(1 << PD3);
		
		
		// initializari variabile pentru verificare corectitudine
		crt = 0;
		done = 0;
		correct = 1;
		
		// cat timp nu s-a tastat toata secventa si secventa tastata e corecta
		while(done == 0 && correct == 1)	
		{			
			button = pressed_button();
			
			PORTA &= ~(1 << PA0);
			PORTA &= ~(1 << PA1);
			PORTA &= ~(1 << PA2);
			PORTA &= ~(1 << PA3);
			PORTA &= ~(1 << PA4);
			PORTA &= ~(1 << PA5);
			PORTA &= ~(1 << PA6);
			PORTA &= ~(1 << PA7);
			PORTD &= ~(1 << PD0);
			PORTD &= ~(1 << PD1);
			PORTD &= ~(1 << PD2);
			PORTD &= ~(1 << PD3);
			_delay_ms(50);
			
			LED_ON(button); 
			_delay_ms(50);	// aprinde ledul butonului apasat
			
			PORTA &= ~(1 << PA0);
			PORTA &= ~(1 << PA1);
			PORTA &= ~(1 << PA2);
			PORTA &= ~(1 << PA3);
			PORTA &= ~(1 << PA4);
			PORTA &= ~(1 << PA5);
			PORTA &= ~(1 << PA6);
			PORTA &= ~(1 << PA7);
			PORTD &= ~(1 << PD0);
			PORTD &= ~(1 << PD1);
			PORTD &= ~(1 << PD2);
			PORTD &= ~(1 << PD3);
			_delay_ms(50);
			
			LED_ON(array[crt]); 
			_delay_ms(50); // aprinde ledul ce trebuia apasat
			
			PORTA &= ~(1 << PA0);
			PORTA &= ~(1 << PA1);
			PORTA &= ~(1 << PA2);
			PORTA &= ~(1 << PA3);
			PORTA &= ~(1 << PA4);
			PORTA &= ~(1 << PA5);
			PORTA &= ~(1 << PA6);
			PORTA &= ~(1 << PA7);
			PORTD &= ~(1 << PD0);
			PORTD &= ~(1 << PD1);
			PORTD &= ~(1 << PD2);
			PORTD &= ~(1 << PD3);
			_delay_ms(50);
			
			if(button != array[crt])	// nu s-a apasat butonul care urma in secventa
			{
				ulevel = 0;
				zlevel = 0;
				correct = 0;
				break;
			}
			crt++;
			if (crt >= 12)
				done = 1;	// s-a introdus corect toata secventa			
		}
		
		// marcheaza castigarea nivelului
		if (correct == 1)
			blink_leds(); 
		
		// actualizeaza nivel
		ulevel++;
		if (ulevel == 10)
		{
			ulevel = 0;
			zlevel++;
		}
		if (zlevel == 10)
		{
			ulevel = zlevel = 0;
		}		
	}
	
	return 0;
}

